
;  TDB_MAIN.ASM -- Main module for TESTD2B2.EXE

.model       small

include      macro.inc                    ;General macro file.

dosseg

.stack

.data
             public  error_type

error_type   db    0                      ;Set by: READ_COMMAND_TAIL.

td2b_syntax  db    '     TESTD2B2 is a mock up of TESTD2B, with source code '
             db    'included, that allows',0dh,0ah
             db    'you to see how HELP.BIN is read into memory (etc.) and '
             db    'how the equate file',0dh,0ah
             db    'HELP.EQU is used. DAT2BIN.EXE must first be used to '
             db    'parse HELP.DAT and create',0dh,0ah
             db    'HELP.BIN and HELP.EQU. All code has been compiled with '
             db    'MASM v5.1 with all',0dh,0ah
             db    'debugging switches on and is ready for CodeView debugging!'
             db    0dh,0ah
             db    'I hereby proclaim, being of unsound mind and body, '
             db    'this program a freebee!',0dh,0ah
             db    'Anyone with suggestions or ideas, please write to:',0dh,0ah
             db    'James R. Webster  113 Riverview Dr  Lafollette, TN'
             db    '  37766. Enjoy!',0dh,0ah,0ah
             db    'Syntax:  DAT2BIN2  [/h /?]  [d:\path\]filename.ext'
             db    0dh,0ah,0ah
             db    '         NOTE: Options must be listed first.',0dh,0ah
             db    '         h or ? = Display this help screen.',0dh,0ah
             db    '       d:\path\ = Valid drive and/or pathname of the '
             db    'binary file,',0dh,0ah
             db    '                  if other than the default drive and '
             db    'pathname.',0dh,0ah
             db    '   filename.ext = The name of the binary file to test.'
             db    0dh,0ah,'$'
td2b_error2  db    7,'      Error: Cannot find binary file!'
             db    0dh,0ah,'$'
td2b_error3  db    7,'      Error: Could not open binary file.'
             db    0dh,0ah,'$'
td2b_error4  db    7,'      Error: Insufficient memory.'
             db    0dh,0ah,'$'

error_addr   dw    offset td2b_syntax
             dw    offset td2b_syntax
             dw    offset td2b_error2
             dw    offset td2b_error3
             dw    offset td2b_error4

comment ~
     TESTD2B2 is a mock up of TESTD2B, with source code included, that allows
you to see how HELP.BIN is read into memory (etc.) and how the equate file
HELP.EQU is used. DAT2BIN.EXE must first be used to parse HELP.DAT and create
HELP.BIN and HELP.EQU. All code has been compiled with MASM v5.1 with all
debugging switches on and is ready for CodeView debugging!
I hereby proclaim, being of unsound mind and body, this program a freebee!
Anyone with suggestions or ideas, please write to:
James R. Webster  113 Riverview Dr  Lafollette, TN  37766. Enjoy!

Syntax:  DAT2BIN2  [/h /?]  [d:\path\]filename.ext

         NOTE: Options must be listed first.
         h or ? = Display this help screen.
       d:\path\ = Valid drive and/or pathname of the binary file,
                  if other than the default drive and pathname.
   filename.ext = The name of the binary file to test.
~
.code
             public  test_d2b_main
             extp    read_command_tail, dealloc
             extp    init_write_char, no_cursor, norm_cursor
             extp    save_dos_screen, restore_dos_screen
             extp    init_test_d2b, read_records

test_d2b_main      proc

             mov   ax,dgroup
             mov   ds,ax
             nop

             call  read_command_tail      ;Check the command line.
             cmp   error_type,0           ;No errors detected ?
             ja    td2b_error             ;If > 0, display the error.
             call  init_test_d2b          ;Initial all parameters.
             jc    td2b_error             ;If carry flag set, error occured.
             call  init_write_char        ;Initial writes to Video Segment.
             call  save_dos_screen        ;Save screen contents.
             call  no_cursor              ;Turn off the hardware cursor.
             call  read_records           ;And do it!!
             call  dealloc                ;Deallocate memory buffer.
             call  restore_dos_screen     ;Restore old screen contents.
             call  norm_cursor            ;Turn back on the hardware cursor.
             mov   al,0                   ;Return error code of 0.
             jmps  exit_test_d2b_main     ;Skip the below.
td2b_error:  pushr <bx,dx>
             lea   bx,error_addr          ;BX = ptr to addresses of errors.
             xor   ah,ah
             mov   al,error_type          ;AX = the error #.
             shl   ax,1                   ;Convert to a word.
             add   bx,ax                  ;BX = adjusted pointer.
             shr   ax,1                   ;AL = return error code.
             mov   dx,wptr [bx]           ;DS:DX = address of error message.
             mov   ah,9                   ;DOS Write String function.
             int   21h
             popr  <dx,bx>
exit_test_d2b_main:
             mov   ah,4ch
             int   21h
             
test_d2b_main      endp

             end   test_d2b_main      
